.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive
assume fs:nothing
include ArmaPatcher.inc

;**********************************************************************************
;                           Disclaimer
;The following code is released for educational purposes and is not ment to be used
;for illegal purposes. The author takes no responsibilty for the way it is used.
;**********************************************************************************
.code

start:
	Push offset errors
	Push offset errorhandle
	mov eax, dword ptr fs: [0]
	Push eax
	mov dword ptr fs: [0], esp	
	invoke GetModuleHandle,NULL
	mov		hInstance,eax
    invoke InitCommonControls
 	invoke DialogBoxParam,hInstance,IDD_DIALOG1,NULL,addr DlgProc,NULL
	invoke ExitProcess,0
errors:
	Pushfd
	mov dword ptr [esp], 202h
	popfd
errorhandle:
	invoke MessageBox, pHandle, offset errortext, offset error, MB_ICONEXCLAMATION+MB_OK
	invoke ExitProcess,0
	ret
	
;########################################################################

DlgProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	mov		eax,uMsg
	m2m pHandle, hWin
	.if eax==WM_INITDIALOG
		Invoke AnimateWindow, hWin, 200, AW_CENTER
		Invoke Initial
    .ELSEIF uMsg == WM_DROPFILES
	  	mov eax, wParam
	  	.if TargetName != 0
	  		Invoke Fail
	  	.else
	   		invoke DragQueryFile,wParam,0,offset TargetName,sizeof TargetName		
	   		invoke DragFinish,wParam
	   		invoke GetDlgItem,hWin,1001
       		invoke SendMessage, eax, LB_ADDSTRING, -1h, offset TargetName
       	.endif
	.elseif eax==WM_COMMAND
		mov eax, wParam
		.if eax == 1002
			.if TargetName == 0
				Invoke FailSecond
			.elseif Restart == 1
				Invoke Fail
			.else
				invoke lstrcpy,offset Buffer,offset TargetName
				invoke lstrcat,offset Buffer,offset Backup							
				invoke CopyFile,offset TargetName,offset Buffer,TRUE
				Invoke GetPEHeader, offset TargetName								
				.if eax == 0h
					invoke MessageBox, hWin, offset errortext, offset error, MB_ICONEXCLAMATION+MB_OK
					invoke ExitProcess,0	
				.endif
				Invoke Update
	   			Invoke CreateProc, offset TargetName								
	   			.if eax == FALSE
	   				invoke MessageBox, hWin, offset errortext, offset error, MB_ICONEXCLAMATION+MB_OK
					invoke ExitProcess,0	
	   			.endif
	   			Invoke GetAddresses
	   			.if eax == 0h
	   				invoke MessageBox, hWin, offset errortext, offset error, MB_ICONEXCLAMATION+MB_OK
					invoke ExitProcess,0
	   			.endif
	   			Invoke EntryPointBreak
	   			invoke WaitEvent
	   			Invoke Update
	   			Invoke Log	
	   			Invoke Update													   			
	   			Invoke FixTime
	   			Invoke Update													
	   			invoke GetDlgItem,hWin,1001
       			invoke SendMessage, eax, LB_ADDSTRING, -1h, offset sPatched
       			mov Restart, 1		
			.endif
	   	.endif
	   	.if eax == 1003
	   		invoke MessageBox, hWin, offset Text, offset Caption, MB_OK		
	   	.endif
	   	.if eax == 1004
	   		invoke EndDialog,hWin,0											
	   	.endif
	.elseif eax==WM_CLOSE
		invoke EndDialog,hWin,0
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret


DlgProc endp

CreateProc Proc  target:DWORD
	
	invoke CreateProcess,target,0,0,0,0,DEBUG_PROCESS,0,0,offset StartupInfo,offset ProcessInfo		
	.if eax != FALSE
		mov eax, offset ProcessInfo
	.endif
	ret

CreateProc endp

GetPEHeader proc target:DWORD
	
	invoke CreateFile, target,GENERIC_READ,FILE_SHARE_READ,0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0		
	.if (eax)
		mov hFile, eax
		invoke CreateFileMapping, hFile, 0, PAGE_READONLY, 0,0,0
		.if (eax)
			mov hMap, eax
			invoke MapViewOfFile, hMap, FILE_MAP_READ, 0,0,0
			.if (eax)
				mov pMem, eax
				add eax,[eax.IMAGE_DOS_HEADER.e_lfanew]
				Push eax
				pop [PeHeaderInfo.PeHeaderAddr]
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.ImageBase]
				pop PeHeaderInfo.ImageBase
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.SizeOfCode]
				pop PeHeaderInfo.SizeOfCode
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.BaseOfCode]
				pop PeHeaderInfo.BaseOfCode
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.BaseOfData]
				pop PeHeaderInfo.BaseOfData
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint]
				pop PeHeaderInfo.EntryPoint
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.SizeOfInitializedData]
				pop PeHeaderInfo.SizeOfInitialized
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.SectionAlignment]
				pop PeHeaderInfo.SectionAlign
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.FileAlignment]
				pop PeHeaderInfo.FileAlign
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage]
				pop PeHeaderInfo.SizeOfImage
				push [eax.IMAGE_NT_HEADERS.OptionalHeader.SizeOfHeaders]
				pop PeHeaderInfo.SizeOfHeader
				push dword ptr [eax+0D8h]  
				pop PeHeaderInfo.ImportAddressTableVA
				push dword ptr [eax+0DCh]  
				pop PeHeaderInfo.ImportAddressTableSize
				add eax, 0F8h												
				mov edi, PeHeaderInfo.ImageBase
				mov esi, PeHeaderInfo.EntryPoint
				add esi, edi
			@@:
				mov ecx, dword ptr [eax+0Ch]
				add ecx, PeHeaderInfo.ImageBase
				add eax, 28h
				cmp ecx, esi
				jbe @B
				sub eax, 50h
				Push dword ptr [eax+8h]									
				pop pVS
				Push dword ptr [eax+0Ch]								
				pop pVA
				Push dword ptr [eax+14h]								
				pop pFO	
			.endif
			invoke UnmapViewOfFile, pMem
		.endif
		invoke CloseHandle, hMap
	.endif
	invoke CloseHandle, hFile										
	ret

GetPEHeader endp

WaitEvent proc
	
Continue:
	Invoke WaitForDebugEvent, offset DebugEvent, INFINITE
	.if DebugEvent.dwDebugEventCode == CREATE_PROCESS_DEBUG_EVENT 
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
	.elseif DebugEvent.dwDebugEventCode == EXIT_PROCESS_DEBUG_EVENT				
		pop eax
		push ProcessInfo.dwProcessId
		Call pDebugStop														
		ret
	.elseif DebugEvent.dwDebugEventCode == CREATE_THREAD_DEBUG_EVENT
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
	.elseif DebugEvent.dwDebugEventCode == EXIT_THREAD_DEBUG_EVENT
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
	.elseif DebugEvent.dwDebugEventCode == LOAD_DLL_DEBUG_EVENT
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
	.elseif DebugEvent.dwDebugEventCode == UNLOAD_DLL_DEBUG_EVENT
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
	.elseif DebugEvent.dwDebugEventCode == EXCEPTION_DEBUG_EVENT
		.if DebugEvent.u.Exception.pExceptionRecord.ExceptionCode==EXCEPTION_BREAKPOINT
			mov Context.ContextFlags, 1001Fh
			invoke GetThreadContext, ProcessInfo.hThread, offset Context
			Push Context.regEip								
			pop esi
			sub esi, 1h
			mov ecx, 1000h
			mov eax, offset BreakPointTable					
		BreakPointCheck:
			mov edi, dword ptr [eax]
			cmp edi, 0h
			je SkipBreakPointCheck
			add eax, 10h
			cmp edi, esi
			jne BreakPointCheck								
			sub eax, 10h
			mov edi, eax
			mov esi, eax
			add esi, 8h
			invoke WriteProcessMemory, ProcessInfo.hProcess, [eax], esi, 1h, 0h		
			mov eax, edi
			mov eax, dword ptr [eax]
			Push eax
			add edi, 4h
			mov edi, dword ptr [edi]
			Call edi										
			Push Context.regFlag
			pop eax
			Push 100h
			Pop Context.regFlag								
			Push Context.regEip
			pop eax
			sub eax, 1h
			push eax
			pop Context.regEip
			invoke SetThreadContext, ProcessInfo.hThread, offset Context
		SkipBreakPointCheck:
			invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_CONTINUE
			Jmp Continue
		.elseif DebugEvent.u.Exception.pExceptionRecord.ExceptionCode==STATUS_SINGLE_STEP
			invoke GetThreadContext, ProcessInfo.hThread, offset Context
			Push Context.regEip
			pop eax
			Push Context.regFlag
			pop eax
			mov eax, offset BreakPointTable
		BreakPointCheck2:
			mov edi, dword ptr [eax]
			cmp edi, 0h
			je SkipSingleStepCheck
			add eax, 10h
			cmp edi, dword ptr [esp]
			jne BreakPointCheck2
			sub eax, 10h
			mov edi, dword ptr [eax]
			add eax, 0Ch
			mov eax, dword ptr [eax]
			.if eax == 1h
				invoke WriteProcessMemory, ProcessInfo.hProcess, edi, offset BreakPoint, 1h, 0h		
			.endif
			pop eax	
			invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_CONTINUE
			Jmp Continue
		SkipSingleStepCheck:
		.endif
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED	
		Jmp Continue
	.elseif DebugEvent.dwDebugEventCode == OUTPUT_DEBUG_STRING_EVENT
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
	.elseif DebugEvent.dwDebugEventCode == RIP_EVENT
		invoke ContinueDebugEvent, DebugEvent.dwProcessId,DebugEvent.dwThreadId, DBG_EXCEPTION_NOT_HANDLED
	.endif
	Jmp Continue
	ret

WaitEvent endp
	
EntryPointBreak proc
	
	Push PeHeaderInfo.ImageBase
	pop eax
	Push PeHeaderInfo.EntryPoint
	pop ebx
	add eax, ebx
	mov edi, offset BreakPointTable
@@:
	mov esi, dword ptr [edi]					
	add edi, 10h
	cmp esi, 0h
	jne @B
	sub edi, 10h
	mov dword ptr [edi], eax					
	add edi, 4h
	mov dword ptr [edi], offset EntryPoint		
	add edi, 4h
	mov esi, eax
	invoke ReadProcessMemory, ProcessInfo.hProcess, eax, edi, 1h, 0h	
	mov eax, esi
	invoke WriteProcessMemory, ProcessInfo.hProcess, eax, offset BreakPoint, 1h, 0h
	Invoke Update			
	ret
	
	
EntryPoint:

	Push PeHeaderInfo.ImportAddressTableVA
	pop eax
	add eax, PeHeaderInfo.ImageBase
	invoke ReadProcessMemory, ProcessInfo.hProcess, eax, offset largebuffer, 950h, 0h
	mov eax, offset largebuffer
	mov edi, pVirtual
@@:
	inc eax
	Cmp dword ptr [eax], edi
	jne @B
	sub eax, offset largebuffer
	add eax, PeHeaderInfo.ImportAddressTableVA					
	add eax, PeHeaderInfo.ImageBase
	mov pVirtualAddress, eax
	mov eax, offset largebuffer
	mov edi, pGetProcaddr
@@:
	inc eax
	Cmp dword ptr [eax], edi
	jne @B
	sub eax, offset largebuffer
	add eax, PeHeaderInfo.ImportAddressTableVA    				
	add eax, PeHeaderInfo.ImageBase
	mov pProcAddress, eax
	mov eax, offset largebuffer
	mov edi, pGetModule
@@:
	inc eax
	Cmp dword ptr [eax], edi
	jne @B
	sub eax, offset largebuffer
	add eax, PeHeaderInfo.ImportAddressTableVA					
	add eax, PeHeaderInfo.ImageBase
	mov pModuleAddress, eax
	Push PeHeaderInfo.EntryPoint
	pop eax
	add eax, PeHeaderInfo.ImageBase
	invoke ReadProcessMemory, ProcessInfo.hProcess, eax, offset largebuffer, 500h, 0h
	mov eax, offset largebuffer
	dec eax
@@:
	inc eax
	cmp byte ptr [eax], 0e8h									
	jne @B
	inc eax
	.if Byte ptr [eax] == 0FFh
	@@:
		inc eax
		cmp word ptr [eax], 0E856h
		jne @B
		inc eax
	.else
		dec eax
	.endif
	sub eax, offset largebuffer
	mov esi, PeHeaderInfo.EntryPoint
	sub esi, pVA
	add eax, esi
	mov pCall, eax
	sub eax, esi
	add eax, offset largebuffer
	inc eax
	mov eax, dword ptr [eax]
	mov pCallInfo, eax
	invoke GlobalAlloc,GMEM_FIXED,20000h					
	mov pMem, eax
	Push PeHeaderInfo.EntryPoint
	pop eax
	add eax, PeHeaderInfo.ImageBase
	invoke ReadProcessMemory, ProcessInfo.hProcess, eax, pMem, 19000h, 0h
	mov eax, pMem
	dec eax
@@:
	inc eax													
	cmp dword ptr [eax], 0h
	jne @B
	inc eax
	cmp dword ptr [eax], 0h									
	jne @B
	inc eax
	cmp dword ptr [eax], 0h
	jne @B
	inc eax
	cmp dword ptr [eax], 0h
	jne @B
	sub eax, 3h
	sub eax, pMem
	mov esi, PeHeaderInfo.EntryPoint							
	sub esi, pVA
	add eax, esi
	mov pLocation, eax
	add eax, PeHeaderInfo.ImageBase
	add eax, pVA
	mov pLocation2, eax
	invoke GlobalFree, pMem
	mov eax, pGetProc
	mov edi, offset BreakPointTable					
@@:
	mov esi, dword ptr [edi]
	add edi, 10h
	cmp esi, 0h
	jne @B
	sub edi, 10h
	mov dword ptr [edi], eax						
	add edi, 4h
	mov dword ptr [edi], offset GetProcRet			
	add edi, 4h
	invoke ReadProcessMemory, ProcessInfo.hProcess, eax, edi, 1h, 0h		
	add edi, 4h
	mov dword ptr [edi], 1h							
	mov eax, pGetProc
	invoke WriteProcessMemory, ProcessInfo.hProcess, eax, offset BreakPoint, 1h, 0h	
	Invoke Update	
	ret

GetProcRet:
	mov Context.ContextFlags, 100F1h										
	invoke GetThreadContext, ProcessInfo.hThread, offset Context
	Push Context.regEsp
	pop eax
	add eax, 0Ch
	Invoke ReadProcessMemory, ProcessInfo.hProcess, eax, offset dw_buffer, 4h, 0h
	mov eax, dw_buffer
	invoke ReadProcessMemory, ProcessInfo.hProcess, eax, offset buffer, 100h, 0h			
	invoke lstrcmp, offset buffer, offset compare									
	.if eax == 0h
		Push Context.regEsp
		pop eax
		add eax, 14h
		invoke ReadProcessMemory,ProcessInfo.hProcess, eax, offset dw_buffer, 4h, 0h
		mov eax, dw_buffer
		invoke ReadProcessMemory,ProcessInfo.hProcess, eax, offset largebuffer, 900h, 0h
		mov eax, offset largebuffer
		mov edi, offset sFourth
		mov edi, dword ptr [edi]
	@@:
		inc eax
		cmp dword ptr [eax], edi
		jne @B
		mov variable, eax 
		sub eax, offset largebuffer
		add eax, dw_buffer
		mov edi, eax
		mov eax, offset BreakPointTable
	@@:
		mov esi, dword ptr [eax]
		add eax, 10h
		cmp esi, 0h
		jne @B
		sub eax, 10h
		mov dword ptr [eax], edi
		add eax, 4h
		mov dword ptr [eax], offset pfourth
		add eax, 4h
		mov esi, eax
		invoke ReadProcessMemory, ProcessInfo.hProcess, edi, eax, 1h, 0h
		mov eax, esi
		invoke WriteProcessMemory, ProcessInfo.hProcess, edi, offset BreakPoint, 1h, 0h
		mov eax, variable
		add eax, 4h
		mov edi, dword ptr [eax]
		mov eax, variable
		add eax, edi
		mov edi, 83h
	@@:
		inc eax
		movzx ebx, byte ptr [eax]
		cmp ebx, edi
		jne @B
		add eax, 3h
		.if byte ptr [eax] == 85h
			Jmp @F
		.else
			sub eax, 3h
		.endif
	@@:
		sub eax, offset largebuffer
		add eax, dw_buffer
		mov edi, eax
		mov eax, offset BreakPointTable
	@@:
		mov esi, dword ptr [eax]
		add eax, 10h
		cmp esi, 0h
		jne @B
		sub eax, 10h
		mov dword ptr [eax], edi
		add eax, 4h
		mov dword ptr [eax], offset pfifth
		add eax, 4h
		mov esi, eax
		invoke ReadProcessMemory, ProcessInfo.hProcess, edi, eax, 1h, 0h
		mov eax, esi
		add eax, 4h
		mov dword ptr [eax], 0h
		invoke WriteProcessMemory, ProcessInfo.hProcess, edi, offset BreakPoint, 1h, 0h 
		mov edi, offset BreakPointTable
		mov eax, pGetProc
	@@:
		add edi, 10h
		cmp [edi], eax
		jne @B
		add edi, 4h
		add edi, 4h
		add edi, 4h
		mov dword ptr [edi], 0h
		mov eax, pOutputDebug
		sub edi, 0Ch
	@@:
		add edi, 10h
		cmp dword ptr [edi], 0h
		jne @B
		mov dword ptr [edi], eax
		add edi, 4h
		mov dword ptr [edi], offset Output
		add edi, 4h
		invoke ReadProcessMemory, ProcessInfo.hProcess, eax, edi, 1h, 0h
		add edi, 4h
		mov dword ptr [edi], 1h
		invoke WriteProcessMemory, ProcessInfo.hProcess, pOutputDebug, offset BreakPoint, 1h, 0h
	.endif
	ret
	
pfourth:
	invoke GetThreadContext, ProcessInfo.hThread, offset Context				
	push 0h
	pop Context.regEcx
	invoke SetThreadContext, ProcessInfo.hThread, offset Context
	ret


pfifth:	
	invoke GetThreadContext, ProcessInfo.hThread, offset Context				
	Push Context.regEax
	pop eax
	.if eax == 10h
		Push 0
		pop Context.regEax
	.endif
	Push Context.regEdx
	pop eax
	.if eax == 10h
		Push 0
		pop Context.regEdx
	.endif
	Push Context.regEcx
	pop eax
	.if eax == 10h
		Push 0
		pop Context.regEcx
	.endif
	Push Context.regEbx
	pop eax
	.if eax == 10h
		Push 0
		pop Context.regEbx
	.endif
	invoke SetThreadContext, ProcessInfo.hThread, offset Context
	Invoke Update
	ret
	

Output:
	.if dword ptr [completed] == 1h
		Invoke Update
		invoke GetThreadContext, ProcessInfo.hThread, offset Context					
		Push Context.regEsp
		pop eax
		invoke ReadProcessMemory, ProcessInfo.hProcess, eax, offset dw_buffer, 4h, 0h
		mov eax, dw_buffer
		invoke ReadProcessMemory,ProcessInfo.hProcess, eax, offset largebuffer, 900h, 0h
		mov eax, offset largebuffer
		mov edi, offset sFirst
		movzx edi, word ptr [edi]
	@@:
		inc eax
		movzx esi, word ptr [eax]
		cmp esi, edi
		jne @B
		add eax, 2h
		movzx edi, byte ptr [eax]
		mov pCRC1, edi
		mov edi, offset sSecond
		movzx edi, word ptr [edi]
	@@:
		inc eax
		movzx esi, word ptr [eax]
		cmp esi, edi
		jne @B
		add eax, 2h
		movzx edi, byte ptr [eax]
		mov [pCRC2], edi
		Push Context.regEbp
		pop eax
		sub eax, 200h
		mov edi, eax
		invoke ReadProcessMemory, ProcessInfo.hProcess, eax, offset largebuffer, 500h, 0h
		neg byte ptr [pCRC1]
		neg byte ptr [pCRC2]
		movzx edi, byte ptr [pCRC2]
		sub edi, 4h
		mov dword ptr [pCRC3], edi
		sub edi, 4h
		mov dword ptr [pCRC4], edi
		sub edi, 4h
		mov dword ptr [pCRC5], edi
		mov eax, offset largebuffer
		add eax, 200h
		sub eax, dword ptr [pCRC1]
		mov edi, dword ptr [eax]
		mov pCRC1Data, edi
		add eax, dword ptr [pCRC1]
		sub eax, dword ptr [pCRC2]		
		mov edi, dword ptr [eax]
		mov pCRC2Data, edi
		add eax, dword ptr [pCRC2]
		sub eax, dword ptr [pCRC3]			
		mov edi, dword ptr [eax]
		mov pCRC3Data, edi
		add eax, dword ptr [pCRC3]
		sub eax, dword ptr [pCRC4]			
		mov edi, dword ptr [eax]
		mov pCRC4Data, edi
		add eax, dword ptr [pCRC4]
		sub eax, dword ptr [pCRC5]			
		mov edi, dword ptr [eax]
		mov pCRC5Data, edi
		invoke TerminateProcess, ProcessInfo.hProcess, 0h
	.endif
	inc dword ptr [completed]
	ret
EntryPointBreak endp	

Fail Proc
	
	invoke GetDlgItem, pHandle,1001
    invoke SendMessage, eax,LB_ADDSTRING, -1h, offset Please	
	ret

Fail endp

FailSecond Proc
	
	invoke GetDlgItem, pHandle,1001
    invoke SendMessage, eax, LB_ADDSTRING, -1h, offset Please2	
	ret

FailSecond endp

Log Proc
	
	pushad
	mov ebx, [pCRC1Data]
	mov ecx, 8h
	mov edi, offset CRC1
	call hex
	invoke lstrcat, offset buffer1, offset sCRC1
	invoke lstrcat, offset buffer1, offset CRC1
	invoke GetDlgItem,pHandle,1001
    invoke SendMessage, eax, LB_ADDSTRING, -1h, offset buffer1
    mov ebx, [pCRC2Data]
	mov ecx, 8h
	mov edi, offset CRC2
	call hex			
	invoke lstrcat, offset buffer2, offset sCRC2
	invoke lstrcat, offset buffer2, offset CRC2
	invoke GetDlgItem,pHandle,1001
    invoke SendMessage, eax, LB_ADDSTRING, -1h, offset buffer2
    mov ebx, [pCRC3Data]
	mov ecx, 8h
	mov edi, offset CRC3
	call hex
	invoke lstrcat, offset buffer3, offset sCRC3
	invoke lstrcat, offset buffer3, offset CRC3
	invoke GetDlgItem,pHandle,1001
    invoke SendMessage, eax, LB_ADDSTRING, -1h, offset buffer3
	mov ebx, [pCRC4Data]
	mov ecx, 8h
	mov edi, offset CRC4
	call hex
	invoke lstrcat, offset buffer4, offset sCRC4
	invoke lstrcat, offset buffer4, offset CRC4
	invoke GetDlgItem,pHandle,1001
    invoke SendMessage, eax, LB_ADDSTRING, -1h, offset buffer4
	mov ebx, [pCRC5Data]
	mov ecx, 8h
	mov edi, offset CRC5
	call hex
	invoke lstrcat, offset buffer5, offset sCRC5
	invoke lstrcat, offset buffer5, offset CRC5
	invoke GetDlgItem,pHandle,1001
    invoke SendMessage, eax, LB_ADDSTRING, -1h, offset buffer5
    popad
	ret

hex:
	mov eax,ebx						
	and al,0fh
	add al,90h
	daa
	adc al,40h
	daa
	shr ebx,4
	mov [edi],al
	inc edi
	dec ecx
	jne hex
	retn

Log endp

GetAddresses Proc
	
	Invoke GetModuleHandle, offset Kernel32	
	.if (eax)
		mov pKernel32, eax
		invoke GetProcAddress, pKernel32, offset DebugStop
		mov pDebugStop, eax	
		invoke GetProcAddress, pKernel32, offset Virtual						
		mov pVirtual, eax
		invoke GetProcAddress, pKernel32, offset GetModule
		mov pGetModule, eax
		invoke GetProcAddress, pKernel32, offset GetProc
		mov pGetProcaddr, eax
		add eax, 5h
		mov pGetProc, eax
		invoke GetProcAddress, pKernel32, offset OutputDebug
		mov pOutputDebug, eax
		mov eax, 1
	.else
		mov eax, 0
	.endif
	ret

GetAddresses endp

Initial Proc
	
	invoke GetDlgItem,pHandle,1006
	m2m hWinProgress, eax
	Mov eax, 100
	mov CurrentStep, eax
	shl eax,16
	invoke SendMessage,hWinProgress,PBM_SETRANGE,0,eax
    invoke SendMessage,hWinProgress,PBM_SETSTEP,10,0
	invoke DragAcceptFiles,pHandle,TRUE								
	invoke GetDlgItem,pHandle,1001
	invoke SendMessage, eax, LB_ADDSTRING, -1h, offset info
	invoke GetDlgItem,pHandle,1001
	invoke SendMessage, eax, LB_ADDSTRING, -1h, offset drag
	ret

Initial endp

Update Proc	

	invoke SendMessage,hWinProgress,PBM_STEPIT,0,0
	ret

Update endp

FixTime Proc	

	Pushad
	neg byte ptr [pCRC1]
	neg byte ptr [pCRC2]
	neg byte ptr [pCRC3]
	neg byte ptr [pCRC4]
	neg byte ptr [pCRC5]
	invoke CreateFile, offset TargetName, GENERIC_READ+FILE_SHARE_WRITE,FILE_SHARE_WRITE+FILE_SHARE_READ, 0,OPEN_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	mov hFile, eax
	invoke CreateFileMapping, hFile, 0,PAGE_READWRITE,0,0,0
	mov hMap, eax
	invoke MapViewOfFile, hMap, FILE_MAP_ALL_ACCESS, 0,0,0
	mov pMemory, eax
	Invoke Update
	mov edi, pLocation
	add edi, pFO
	mov eax, edi
	mov pLocation, eax
	mov esi, offset movecode
	mov ecx, offset endarea
	sub ecx, esi
	mov eax, [pLocation]
	add eax, [pMemory]
	mov pAddress, eax
	mov edi, eax
	rep movs byte ptr [edi], [esi]
	mov edi, dword ptr [pLocation2]
	mov esi, dword ptr [pAddress]
	mov dword ptr [esi+3h], edi
	mov dword ptr [esi+5Eh], edi
	add edi, 0B1h
	mov dword ptr [esi+8h], edi	
	mov edi, dword ptr [pLocation2]
	add edi, 0BEh
	mov dword ptr [esi+19h], edi
	mov edi, dword ptr [pAddress]
	add edi, 06dh
	movzx eax, byte ptr [pCRC1]
	mov dword ptr [edi], eax
	mov eax, dword ptr [pCRC1Data]
	mov dword ptr [edi+1h], eax
	mov edi, dword ptr [pAddress]
	add edi, 074h
	movzx eax, byte ptr [pCRC2]
	mov dword ptr [edi], eax
	mov eax, dword ptr [pCRC2Data]
	mov dword ptr [edi+1h], eax
	mov edi, dword ptr [pAddress]
	add edi, 07bh
	movzx eax, byte ptr [pCRC3]
	mov dword ptr [edi], eax
	mov eax, dword ptr [pCRC3Data]
	mov dword ptr [edi+1h], eax
	mov edi, dword ptr [pAddress]
	add edi, 082h
	movzx eax, byte ptr [pCRC4]
	mov dword ptr [edi], eax
	mov eax, dword ptr [pCRC4Data]
	mov dword ptr [edi+1h], eax
	mov edi, dword ptr [pAddress]
	add edi, 089h
	movzx eax, byte ptr [pCRC5]
	mov dword ptr [edi], eax
	mov eax, dword ptr [pCRC5Data]
	mov dword ptr [edi+1h], eax
	mov edi, dword ptr [pAddress]
	mov eax, dword ptr [pModuleAddress]
	mov dword ptr [edi+0eh], eax
	mov eax, dword ptr [pProcAddress]
	mov dword ptr [edi+20h], eax
	mov eax, dword ptr [pVirtualAddress]
	mov dword ptr [edi+3dh], eax
	mov eax,[pCall]
	add eax, PeHeaderInfo.ImageBase
	add eax, pVA
	add eax, 5h
	mov edi, dword ptr [pLocation2]
	sub edi, eax
	mov eax,[pCall]
	add eax, pFO
	add eax, [pMemory]
	add eax, 1h
	mov dword ptr [eax], edi
	mov eax,[pCall]
	add eax, PeHeaderInfo.ImageBase
	add eax, pVA
	add eax, 5h
	mov esi, [pCallInfo]
	add eax, esi
	mov edi, dword ptr [pLocation2]
	add edi, 5dh
	sub eax, edi
	mov edi, dword ptr [pAddress]
	mov dword ptr [edi+59h], eax
endfixcode:
	Invoke Update
	Invoke UnmapViewOfFile, pMemory
	invoke CloseHandle, hMap
	invoke CloseHandle, hFile
	popad	
	ret
movecode:
PUSHAD
PUSHFD
MOV EDI,004BF00Bh
PUSH 004BF0B5h                   
CALL DWORD PTR DS:[00000000]
MOV DWORD PTR [EDI+0D1h],EAX														
PUSH 004BF0C3h                   
PUSH EAX																				
CALL DWORD PTR DS:[00000000] 
MOV DWORD PTR [EDI+0D5h],EAX															
MOV ESI,EDI																					
ADD ESI,0D9h 																				
PUSH ESI
PUSH 80h
PUSH 8h
PUSH EAX
CALL DWORD PTR DS:[00000000]
MOV EAX,DWORD PTR [EDI+0D5h]
MOV BYTE PTR DS:[EAX],68h
MOV ESI,EDI
ADD ESI,5Dh																				
MOV DWORD PTR DS:[EAX+1],ESI
MOV BYTE PTR [EAX+5h],0C3h
POPFD
POPAD
Jmp FixTime
MOV EAX,004BF00Bh																	
CMP BYTE PTR DS:[EAX+0DDh],1
JNZ over
MOV DWORD PTR SS:[EBP-22],12345678; 												
MOV DWORD PTR SS:[EBP-22],12345678; 													
MOV DWORD PTR SS:[EBP-22],12345678;												
MOV DWORD PTR SS:[EBP-22],12345678; 									
MOV DWORD PTR SS:[EBP-22],12345678;	
PUSHAD
MOV EAX,DWORD PTR DS:[EAX+0D5h]
MOV DWORD PTR DS:[EAX],1B8h
MOV DWORD PTR DS:[EAX+4h],4C200h
POPAD
over:
INC BYTE PTR DS:[EAX+0DDh]
MOV EAX,1
RETN 4
db 4Bh, 65h, 72h, 6Eh, 65h, 6Ch, 33h, 32h, 2Eh, 64h, 6Ch, 6Ch, 00h, 4Fh, 75h, 74h, 70h, 75h, 74h, 44h, 65h, 62h, 75h, 67h, 53h, 74h, 72h, 69h, 6Eh, 67h, 41h, 00h
endarea:
db 00h, 00h, 00h, 00h
ret
FixTime endp

end start


























